<?php

namespace Lc\PietroBundle\Solver\Workshop;

use Lc\PietroBundle\Model\Workshop\WorkshopInterface;

class WorkshopSolver
{
    public function countEntriesAnimators(WorkshopInterface $workshop): int
    {
        return count($this->getEntriesByIsAnimator($workshop, true));
    }

    public function countEntriesRegistered(WorkshopInterface $workshop): int
    {
        return count($this->getEntriesByIsAnimator($workshop, false));
    }

    public function getEntriesRegistered(WorkshopInterface $workshop)
    {
        return $this->getEntriesByIsAnimator($workshop, false);
    }

    public function getEntriesAnimators(WorkshopInterface $workshop)
    {
        return $this->getEntriesByIsAnimator($workshop, true);
    }

    public function getEntriesByIsAnimator(WorkshopInterface $workshop, bool $isAnimator): array
    {
        $entryArray = [];

        foreach($workshop->getEntries() as $entry) {
            if($entry->isAnimator() == $isAnimator) {
                $entryArray[] = $entry;
            }
        }

        return $entryArray;
    }
}